pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT > Class Template Reference

Surface normal estimation on dense data using a least-squares estimation based on a first-order Taylor approximation. More...

`#include <pcl/features/linear_least_squares_normal.h>`

Inheritance diagram for pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >:

## Public Types

typedef boost::shared_ptr< LinearLeastSquaresNormalEstimation< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const LinearLeastSquaresNormalEstimation< PointInT, PointOutT > > | ConstPtr
typedef Feature< PointInT, PointOutT >::PointCloudIn | PointCloudIn
typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| LinearLeastSquaresNormalEstimation ()
| Constructor. More...
virtual | ~LinearLeastSquaresNormalEstimation ()
| Destructor. More...
void | computePointNormal (const int pos_x, const int pos_y, PointOutT &normal)
| Computes the normal at the specified position. More...
void | setNormalSmoothingSize (float normal_smoothing_size)
| Set the normal smoothing size. More...
void | setDepthDependentSmoothing (bool use_depth_dependent_smoothing)
| Set whether to use depth depending smoothing or not. More...
void | setMaxDepthChangeFactor (float max_depth_change_factor)
| The depth change threshold for computing object borders. More...
virtual void | setInputCloud (const typename PointCloudIn::ConstPtr &cloud)
| Provide a pointer to the input dataset (overwrites the PCLBase::setInputCloud method) More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (PointCloudOut &output)
| Computes the normal for the complete cloud. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT>
class pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >

Surface normal estimation on dense data using a least-squares estimation based on a first-order Taylor approximation.

Author
  Stefan Holzer, Cedric Cagniart

Definition at line 52 of file linear_least_squares_normal.h.

## Member Typedef Documentation

template<typename PointInT, typename PointOutT>

typedef boost::shared_ptr<const LinearLeastSquaresNormalEstimation<PointInT, PointOutT> > pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::ConstPtr

Definition at line 56 of file linear_least_squares_normal.h.

template<typename PointInT, typename PointOutT>

typedef Feature<PointInT, PointOutT>::PointCloudIn pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::PointCloudIn

Definition at line 57 of file linear_least_squares_normal.h.

template<typename PointInT, typename PointOutT>

typedef Feature<PointInT, PointOutT>::PointCloudOut pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::PointCloudOut

Definition at line 58 of file linear_least_squares_normal.h.

template<typename PointInT, typename PointOutT>

typedef boost::shared_ptr<LinearLeastSquaresNormalEstimation<PointInT, PointOutT> > pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::Ptr

Definition at line 55 of file linear_least_squares_normal.h.

## Constructor & Destructor Documentation

template<typename PointInT, typename PointOutT>

pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::LinearLeastSquaresNormalEstimation | ( |  | ) |

inline

Constructor.

Definition at line 65 of file linear_least_squares_normal.h.

References pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::computePointNormal(), pcl::Feature< PointInT, PointOutT >::feature_name_, pcl::Feature< PointInT, PointOutT >::k_, pcl::Feature< PointInT, PointOutT >::tree_, and pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::~LinearLeastSquaresNormalEstimation().

template<typename PointInT , typename PointOutT >

pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::~LinearLeastSquaresNormalEstimation | ( |  | ) |

virtual

Destructor.

Definition at line 47 of file linear_least_squares_normal.hpp.

Referenced by pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::LinearLeastSquaresNormalEstimation().

## Member Function Documentation

template<typename PointInT , typename PointOutT >

void pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

protected virtual

Computes the normal for the complete cloud.

Parameters

  [out] | output | the resultant normals

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 155 of file linear_least_squares_normal.hpp.

References pcl::PointCloud< PointT >::points.

Referenced by pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::setInputCloud().

template<typename PointInT , typename PointOutT >

void pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::computePointNormal | ( | const int | pos_x,
|  | const int | pos_y,
|  | PointOutT & | normal
| ) |  |

Computes the normal at the specified position.

Parameters

  [in] | pos_x | x position (pixel)
  [in] | pos_y | y position (pixel)
  [out] | normal | the output estimated normal

Definition at line 53 of file linear_least_squares_normal.hpp.

Referenced by pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::LinearLeastSquaresNormalEstimation().

template<typename PointInT, typename PointOutT>

void pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::setDepthDependentSmoothing | ( | bool | use_depth_dependent_smoothing | ) |

inline

Set whether to use depth depending smoothing or not.

Parameters

  [in] | use_depth_dependent_smoothing | decides whether the smoothing is depth dependent

Definition at line 100 of file linear_least_squares_normal.h.

Referenced by pcl::SurfaceNormalModality< PointInT >::computeSurfaceNormals().

template<typename PointInT, typename PointOutT>

virtual void pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::setInputCloud | ( | const typename PointCloudIn::ConstPtr & | cloud | ) |

inline virtual

Provide a pointer to the input dataset (overwrites the PCLBase::setInputCloud method)

Parameters

  [in] | cloud | the const boost shared pointer to a PointCloud message

Definition at line 119 of file linear_least_squares_normal.h.

References pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::computeFeature(), and pcl::PCLBase< PointInT >::input_.

Referenced by pcl::SurfaceNormalModality< PointInT >::computeSurfaceNormals().

template<typename PointInT, typename PointOutT>

void pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::setMaxDepthChangeFactor | ( | float | max_depth_change_factor | ) |

inline

The depth change threshold for computing object borders.

Parameters

  [in] | max_depth_change_factor | the depth change threshold for computing object borders based on depth changes

Definition at line 110 of file linear_least_squares_normal.h.

Referenced by pcl::SurfaceNormalModality< PointInT >::computeSurfaceNormals().

template<typename PointInT, typename PointOutT>

void pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::setNormalSmoothingSize | ( | float | normal_smoothing_size | ) |

inline

Set the normal smoothing size.

Parameters

  [in] | normal_smoothing_size | factor which influences the size of the area used to smooth normals (depth dependent if useDepthDependentSmoothing is true)

Definition at line 91 of file linear_least_squares_normal.h.

Referenced by pcl::SurfaceNormalModality< PointInT >::computeSurfaceNormals().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/linear_least_squares_normal.h
- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/impl/linear_least_squares_normal.hpp